﻿RandomGuy = LibStub("AceAddon-3.0"):NewAddon("RandomGuy", "AceEvent-3.0", "AceTimer-3.0")
local randomguy_options
local L = {
	["defaultannounce"] = "Item will be assigned using /rnd $r. Numbers are being whispered in 1 second.",
	["defaultwhisper"] = "You are raid member number $n!",
	["defaultformat"] = "$n - $c",
	["announceset"] = "Announcement set: ",
	["whisperset"] = "Whisper text set: ",
	["formatset"] = "Local Output format set: ",
	["delayset"] = "Delay set: ",
}
if GetLocale() == "deDE" then
	L = {
		["defaultannounce"] = "Gegenstand wird mit /rnd $r vergeben. Eure Zahl wird euch in 1 Sekunde per Whisper mitgeteilt.",
		["defaultwhisper"] = "Du bist Nummer $n!",
		["defaultformat"] = "$n - $c",
		["announceset"] = "Ankündigungstext gesetzt: ",
		["whisperset"] = "Flüstertext gesetzt: ",
		["formatset"] = "Format der lokalen Auflistung gesetzt: ",
		["delayset"] = "Verzögerung gesetzt: ",
	}
end
if GetLocale() == "deDE" then
	randomguy_options = {
		name = "RandomGuy",
		handler = RandomGuy,
		type = 'group',
		args = {
			roll = {
				type = 'input',
				name = 'roll',
				desc = 'Startet den Verteilungsprozess',
				set = 'DoRaidRoll',
				get = 'DummyFunc',
			},
			announce = {
				type = 'input',
				name = 'Announce',
				desc = 'Setzt den Text, der den Roll ankündigt. Variablen: $r - Anzahl der Raidmitglieder',
				set = 'setannouncetext',
				get = 'DummyFunc',
			},
			whisper = {
				type = 'input',
				name = 'Whisper',
				desc = 'Setzt den Text, mit dem den Raidmitgliedern die jeweilige Nummer mitgeteilt wird. Variablen: $n - Nummer des Mitglieds',
				set = 'setwhispertext',
				get = 'DummyFunc',			
			},
			format = {
				type = 'input',
				name = 'LocalOutput',
				desc = 'Setzt das Format der lokalen Nummernanzeige. Variablen: $n - Nummer des Mitglieds $c - Name des Charakters',
				set = 'SetLocalOutputText',
				get = 'DummyFunc',
			},
			delay = {
				type = 'input',
				name = 'Delay',
				desc = 'Setzt die Verzögerung, bevor die lokale Liste angezeigt wird. Falls die Whispers nach der Liste angezeigt werden, versuche diese Zahl zu erhöhen.',
				set = 'setdelay',
				get = 'DummyFunc',
			},
		},
	}
	DEFAULT_CHAT_FRAME:AddMessage("RandomGuy erfolgreich geladen.");
else
	randomguy_options = {
		name = "RandomGuy",
		handler = RandomGuy,
		type = 'group',
		args = {
			roll = {
				type = 'input',
				name = 'roll',
				desc = 'Performs a raid roll.',
				set = 'DoRaidRoll',
				get = 'DummyFunc',
			},
			announce = {
				type = 'input',
				name = 'Announce',
				desc = 'Set the text announcing the roll. Variables: $r - Number of Raid Members',
				set = 'setannouncetext',
				get = 'DummyFunc',
			},
			whisper = {
				type = 'input',
				name = 'Whisper',
				desc = 'Set the text telling Raid Members their number. Variables: $n - number of the raid member',
				set = 'setwhispertext',
				get = 'DummyFunc',			
			},
			format = {
				type = 'input',
				name = 'LocalOutput',
				desc = 'Set the text of the local raid member list. Variables: $n - member\'s number $c - member\'s name',
				set = 'SetLocalOutputText',
				get = 'DummyFunc',
			},
			delay = {
				type = 'input',
				name = 'Delay',
				desc = 'Set the delay until the local list is displayed. Increase this, if lag causes whispers to be displayed after the local list.',
				set = 'setdelay',
				get = 'DummyFunc',
			},
		},
	}
	DEFAULT_CHAT_FRAME:AddMessage("RandomGuy loaded successfully.");
end
function RandomGuy:setdelay(info, input)
	input = tonumber(input);
	if input then
		RandomGuyData.delay = input;
		DEFAULT_CHAT_FRAME:AddMessage(L["delayset"]..input);
	end
end
function RandomGuy:setannouncetext(info, input)
	if not (input=="") then
		RandomGuyData.announce = input;
		DEFAULT_CHAT_FRAME:AddMessage(L["announceset"]..input);
	end
end
function RandomGuy:setwhispertext(info, input)
	if not (input == "") then
		RandomGuyData.whisper = input;
		DEFAULT_CHAT_FRAME:AddMessage(L["whisperset"]..input);
	end
end
function RandomGuy:SetLocalOutputText(info, input)
	if not (input == "") then
		RandomGuyData.output = input;
		DEFAULT_CHAT_FRAME:AddMessage(L["formatset"]..input);
	end
end
function RandomGuy:DummyFunc(info)
	return nil
end
function RandomGuy:PostThisGuysLocal(datatable)
	local number = datatable[1];
	local name = datatable[2];
	local output = string.gsub(RandomGuyData.output, "$n", number);
	local output = string.gsub(output, "$c", name);
	DEFAULT_CHAT_FRAME:AddMessage(output);
end
function RandomGuy:DoRandomRoll(tehmax)
	RandomRoll(1, tehmax);
end
function RandomGuy:WhisperNumbers()
	for i=1, GetNumRaidMembers() do
		local message = string.gsub(RandomGuyData.whisper, "$n", i);
		SendChatMessage("<RandomGuy>"..message, "WHISPER", nil, UnitName("raid"..i));
		RandomGuy:ScheduleTimer("PostThisGuysLocal", RandomGuyData.delay, {i, UnitName("raid"..i)});
	end
	RandomGuy:ScheduleTimer("DoRandomRoll", RandomGuyData.delay+1, GetNumRaidMembers());
end
function RandomGuy:DoRaidRoll(info, input)
	local announce = string.gsub(RandomGuyData.announce, "$r", GetNumRaidMembers());
	SendChatMessage("<RandomGuy>"..announce, "RAID");
	RandomGuy:ScheduleTimer("WhisperNumbers", 1);
end
function RandomGuy:OnInitialize()
	if not RandomGuyData then
		RandomGuyData = {};
	end
	if not RandomGuyData.output then
		RandomGuyData.output = L["defaultformat"];
	end
	if not RandomGuyData.whisper then
		RandomGuyData.whisper = L["defaultwhisper"];
	end
	if not RandomGuyData.announce then
		RandomGuyData.announce = L["defaultannounce"];
	end
	if not RandomGuyData.delay then
		RandomGuyData.delay = 2;
	end
	LibStub("AceConfig-3.0"):RegisterOptionsTable("RandomGuy", randomguy_options, {"randomguy", "rg"});
end
